import javax.swing.*;
import java.awt.*;

/**
 * A class that represents a (finite) board for Conway's Life.
 * 
 * @author YOUR_NAME_HERE and YOUR_PARTNER'S_NAME_HERE
 */

public class Life extends JPanel {

    // The delay between frames of the animation, in milliseconds. You
    // can change this if you want it to run faster or slower.
    public final static int ANIMATION_DELAY = 100;

    // The size of one cell one the screen, in pixels. You can make this
    // smaller if you make a big board.
    public final static int CELL_SIZE = 20;

    // Width and height of the board, in cells.
    public final static int BOARD_WIDTH = 25;
    public final static int BOARD_HEIGHT = 25;


    // TODO: YOUR INSTANCE VARIABLES HERE

    /**
     * A constructor for a new Life game
     */
    public Life()
    {
        
    }

    /**
     * Returns whether or not a cell is alive.
     * @param x the x coord of the cell
     * @param y the y coord of the cell
     * @return whether the cell is alive or not
     */
    public boolean isAlive(int x, int y)
    {
        //TODO: FILL THIS IN
    }

    
    /**
     * Updates the board for the next generation
     */
    public void nextGeneration()
    {
        // TODO: FILL THIS IN
    }
   
    /**
     * Returns the number of living neighbors next to a cell.
     * @param x the x coord of the cell
     * @param y the y coord of the cell
     * @return the number of living neighbors next to the cell
     */
    public int countNeighbors(int x, int y)
    {
        //TODO: FILL THIS IN
        return -1; //TEMPORARY, REMOVE THIS!
    }
    
    
    // TODO: YOUR OTHER METHODS HERE


    /**
     * Draws the board
     */
    public void paintComponent(Graphics g)
    {
        nextGeneration();
        
        g.setColor(Color.WHITE);
        g.fillRect(0,0,FRAME_WIDTH,FRAME_HEIGHT);

        for (int x = 0; x < BOARD_WIDTH; x++)
        {
            for (int y = 0; y < BOARD_HEIGHT; y++)
            {
                if(isAlive(x,y))
                {
                    g.setColor(Color.BLACK);
                    g.fillRect(x*CELL_SIZE, y*CELL_SIZE, CELL_SIZE, CELL_SIZE);
                }
            }
        }
    }
    
    /****CONSTANTS FOR YOUR CONVENIENCE --- DO NOT MODIFY****/
    public final static int FRAME_WIDTH = BOARD_WIDTH*CELL_SIZE;
    public final static int FRAME_HEIGHT = BOARD_HEIGHT*CELL_SIZE;
    /**** END CONSTANTS ****/
}
